<!DOCTYPE html>
<html lang="zh-CN">
<head>
    <meta charset="UTF-8">
    <title>聊天界面</title>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script>
        var socket = new WebSocket('ws://localhost:8080');
        var token = "<?php echo $_GET['token'];?>";

        socket.onopen = function (event) {
            console.log('连接已建立');
            sendToken();
        };

        socket.onmessage = function (event) {
            var data = JSON.parse(event.data);
            if (data.type ==='message') {
                $('#chat-messages').append('<p><strong>' + data.sender + '</strong>: '+ data.content + '</p>');
            } else if (data.type === 'online-users') {
                $('#online-users').html('');
                data.users.forEach(function (user) {
                    $('#online-users').append('<li>' + user + '</li>');
                });
            } else if (data.type ==='recall') {
                $('#chat-messages').find('p:contains("'+ data.sender +': '+ data.content + '")').remove();
                alert(data.sender + '撤回了一条消息');
            }
        };

        function sendToken() {
            socket.send(JSON.stringify({type: 'token', token: token}));
        }

        $(document).ready(function () {
            $('#send-message').click(function () {
                var message = $('#message-input').val();
                if (message) {
                    socket.send(JSON.stringify({type:'message', content: message, token: token}));
                    $('#message-input').val('');
                }
            });
        });
    </script>
</head>
<body>
    <h1>实时聊天</h1>
    <div id="chat-messages"></div>
    <input type="text" id="message-input" placeholder="输入消息">
    <button id="send-message">发送</button>
    <h2>在线用户</h2>
    <ul id="online-users"></ul>
</body>
</html>
