<?php
require_once __DIR__. '/vendor/autoload.php';

use Ratchet\MessageComponentInterface;
use Ratchet\ConnectionInterface;
use Ratchet\Server\IoServer;
use Ratchet\Http\HttpServer;
use Ratchet\WebSocket\WsServer;

require_once 'db.php';

class Chat implements MessageComponentInterface
{
    protected $clients;
    protected $userSockets = [];
    protected $userIds = [];

    public function __construct()
    {
        $this->clients = new \SplObjectStorage;
    }

    public function onOpen(ConnectionInterface $conn)
    {
        $this->clients->attach($conn);
        echo "New connection! ({$conn->resourceId})\n";
    }

    public function onMessage(ConnectionInterface $from, $msg)
    {
        $data = json_decode($msg, true);
        if ($data['type'] === 'token') {
            $sql = "SELECT id FROM users WHERE token = '". $data['token']."'";
            $result = $conn->query($sql);
            if ($result->num_rows == 1) {
                $row = $result->fetch_assoc();
                $this->userSockets[$row['id']] = $from;
                $this->userIds[$from->resourceId] = $row['id'];
                $this->sendOnlineUsers();
            }
        } elseif ($data['type'] ==='message') {
            $sql = "SELECT id FROM users WHERE token = '". $data['token']."'";
            $result = $conn->query($sql);
            if ($result->num_rows == 1) {
                $row = $result->fetch_assoc();
                $senderId = $row['id'];
                $sql = "INSERT INTO messages (sender_id, content, sent_at) VALUES ($senderId, '". $data['content']."', NOW())";
                $conn->query($sql);
                $senderSql = "SELECT username FROM users WHERE id = $senderId";
                $senderResult = $conn->query($senderSql);
                $senderRow = $senderResult->fetch_assoc();
                $sender = $senderRow['username'];
                $messageData = array("type" => "message", "sender" => $sender, "content" => $data['content']);
                foreach ($this->clients as $client) {
                    $client->send(json_encode($messageData));
                }
            }
        } elseif ($data['type'] ==='recall') {
            $sql = "SELECT id FROM users WHERE token = '". $data['token']."'";
            $result = $conn->query($sql);
            if ($result->num_rows == 1) {
                $row = $result->fetch_assoc();
                $senderId = $row['id'];
                $sql = "SELECT id, content FROM messages WHERE sender_id = $senderId AND content = '". $data['content']."' AND sent_at >= DATE_SUB(NOW(), INTERVAL 5 MINUTE)";
                $recallResult = $conn->query($sql);
                if ($recallResult->num_rows == 1) {
                    $recallRow = $recallResult->fetch_assoc();
                    $messageId = $recallRow['id'];
                    $sql = "DELETE FROM messages WHERE id = $messageId";
                    $conn->query($sql);
                    $senderSql = "SELECT username FROM users WHERE id = $senderId";
                    $senderResult = $conn->query($senderSql);
                    $senderRow = $senderResult->fetch_assoc();
                    $sender = $senderRow['username'];
                    $recallData = array("type" => "recall", "sender" => $sender, "content" => $data['content']);
                    foreach ($this->clients as $client) {
                        $client->send(json_encode($recallData));
                    }
                }
            }
        }
    }

    public function sendOnlineUsers()
    {
        $userIds = array_keys($this->userSockets);
        $userNames = [];
        foreach ($userIds as $userId) {
            $sql = "SELECT username FROM users WHERE id = $userId";
            $result = $conn->query($sql);
            if ($result->num_rows == 1) {
                $row = $result->fetch_assoc();
                $userNames[] = $row['username'];
            }
        }
        $onlineUsersData = array("type" => "online-users", "users" => $userNames);
        foreach ($this->clients as $client) {
            $client->send(json_encode($onlineUsersData));
        }
    }

    public function onClose(ConnectionInterface $conn)
    {
        $this->clients->detach($conn);
        if (isset($this->userIds[$conn->resourceId])) {
            unset($this->userSockets[$this->userIds[$conn->resourceId]]);
            unset($this->userIds[$conn->resourceId]);
            $this->sendOnlineUsers();
        }
        echo "Connection {$conn->resourceId} has disconnected\n";
    }

    public function onError(ConnectionInterface $conn, \Exception $e)
    {
        echo "An error has occurred: ". $e->getMessage(). "\n";
        $conn->close();
    }
}

$server = IoServer::factory(
    new HttpServer(
        new WsServer(
            new Chat()
        )
    ),
    8080
);

$server->run();
